/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "stun.h"
#include "xcom.h"
#include "patcher.h"

static menu_item *tmp_item;
static int stunStats;
static int stunActivated=0;

#define RETURN(damage,tu) (((damage)<<16)|((tu)&0xffff))
#define DAMAGE(x) (((unsigned)(x))>>16)
#define TU(x) ((x)&0xffff)

static int GetWeaponStunStats(int itemType)
{
	if(itemType>42)
		return 0;

	switch(itemType)
	{
//Pistols
	case 0: //pistol
	case 16://laser pistol
	case 38://plasma pistol
		return RETURN(20,15);//small damage but small TU
//Rifles
	case 2: //rifle
	case 17://laser gun
	case 36://plasma rifle
	case 42://small launcher
		return RETURN(50,40);
//Cannons
	case 4: //heavy cannon
	case 8: //auto cannon
	case 18://heavy laser
	case 34://heavy plasma
		return RETURN(65,50);
//launchers
	case 12://Rocket launcher
	case 40://blaster launcher
		return RETURN(80,80);
	default:
		return 0;
	}
}

__declspec(naked) void StunPopulateMenu()
{
//dl -> itemtype
//di -> weaponstrength
//bx -> damagetype

	__asm
	{
		//heavy laser only
		cmp stunActivated, 0
		jz skip
		push edx
		call GetWeaponStunStats
		add esp,4
		cmp eax,0
		jz skip
		mov stunStats,eax
	}

	tmp_item=&WeaponMenu_Items[*WeaponMenu_NumEntries];

	tmp_item->accuracy=100;
	tmp_item->actionType=6;//"Stun"
	tmp_item->damageType=5;//stun
	tmp_item->TUusage=(*currentUnit_pUnitRef)->TUs_Max*TU(stunStats)/100;
	tmp_item->weaponStrength=DAMAGE(stunStats);

	(*WeaponMenu_NumEntries)++;

	__asm
	{
skip:
		pop     edi
		pop     esi
		pop     ebp
		pop     ebx
		add     esp, 0x0C
		retn
	}
}

void ModStun()
{
	stunActivated=1;
	InsertJmp(0x41DA59,StunPopulateMenu);
}
